package java.util.concurrent;

import java.util.Iterator;
import java.util.Deque;

public interface BlockingDeque<E> extends BlockingQueue<E>, Deque<E>
{
    public abstract void addFirst(E p0);
    
    public abstract void addLast(E p0);
    
    public abstract boolean offerFirst(E p0);
    
    public abstract boolean offerLast(E p0);
    
    public abstract void putFirst(E p0) throws InterruptedException;
    
    public abstract void putLast(E p0) throws InterruptedException;
    
    public abstract boolean offerFirst(E p0, long p1, TimeUnit p2) throws InterruptedException;
    
    public abstract boolean offerLast(E p0, long p1, TimeUnit p2) throws InterruptedException;
    
    public abstract E takeFirst() throws InterruptedException;
    
    public abstract E takeLast() throws InterruptedException;
    
    public abstract E pollFirst(long p0, TimeUnit p1) throws InterruptedException;
    
    public abstract E pollLast(long p0, TimeUnit p1) throws InterruptedException;
    
    public abstract boolean removeFirstOccurrence(Object p0);
    
    public abstract boolean removeLastOccurrence(Object p0);
    
    public abstract boolean add(E p0);
    
    public abstract boolean offer(E p0);
    
    public abstract void put(E p0) throws InterruptedException;
    
    public abstract boolean offer(E p0, long p1, TimeUnit p2) throws InterruptedException;
    
    public abstract E remove();
    
    public abstract E poll();
    
    public abstract E take() throws InterruptedException;
    
    public abstract E poll(long p0, TimeUnit p1) throws InterruptedException;
    
    public abstract E element();
    
    public abstract E peek();
    
    public abstract boolean remove(Object p0);
    
    public abstract boolean contains(Object p0);
    
    public abstract int size();
    
    public abstract Iterator<E> iterator();
    
    public abstract void push(E p0);
}
